SystemOrganization addCategory: #'Mustache-Tests'!

MustacheTemplate subclass: #MustacheTest1
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mustache-Tests'!

!MustacheTest1 methodsFor: 'as yet unclassified' stamp: 'JesusMari 6/18/2012 13:14'!
render
	"return an Template within a string"

^'Simple test

Hello {{name}}
you work as a {{profession}}'! !

MustacheTemplate subclass: #MustacheTest2
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mustache-Tests'!

!MustacheTest2 methodsFor: 'as yet unclassified' stamp: 'JesusMari 9/23/2012 20:38'!
render
	"return an Template within a string"

^'Function test
Hello {{name}}
you work as a {{profession}}
Your salary is ${{salary}}!!
{{#inCa}}
Ok, in fact it is ${{funcion}} after you pay the taxes.
{{/inCa}}
{{#person}}
Ok, in fact it is ${{funcion}} 
{{/person}}
'! !

MustacheTemplate subclass: #MustacheTest3
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mustache-Tests'!

!MustacheTest3 methodsFor: 'as yet unclassified' stamp: 'JesusMari 6/18/2012 13:15'!
render
	"return an Template within a string"

^'Escaped/non escaped test

*{{name}}
*{{profession}}
*{{company}}
*{{{company}}}
'! !

MustacheTemplate subclass: #MustacheTest4
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mustache-Tests'!

!MustacheTest4 methodsFor: 'as yet unclassified' stamp: 'JesusMari 11/7/2012 12:53'!
render
	"return an Template within a string"

^'Non Empty List test

{{name}}
{{profession}}
{{company}}
*non escaped company:{{{company}}}
{{#experience}}
--{{name}}--->{{job}}
{{/experience}}

'! !

MustacheTemplate subclass: #MustacheTest5
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mustache-Tests'!

!MustacheTest5 methodsFor: 'as yet unclassified' stamp: 'JesusMari 12/20/2012 05:01'!
render
	"return an Template within a string"

^'Lambdas test

Name:{{name}}, Profession:{{profession}}
Working at:{{company}}
------------------------------------------
Experience
{{#experience}}
{{job}}
{{[
	buffer nextPutAll:''How are you''.	
	]}}
{{/experience}}
------------------------------------------
Salary:
{{#wrapped}}
{{salary}}
{{/wrapped}}

'! !

MustacheTemplate subclass: #MustacheTest6
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mustache-Tests'!

!MustacheTest6 methodsFor: 'as yet unclassified' stamp: 'JesusMari 12/17/2012 20:27'!
render
	"return an Template within a string"

^'Non False Values Test

Hash:
{
	"person" :{"name": "Jon"}
}

Template:
{{#person}}
Hi {{name}}!!
{{/person}}
'! !

MustacheTemplate subclass: #MustacheTest7
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mustache-Tests'!

!MustacheTest7 methodsFor: 'as yet unclassified' stamp: 'JesusMari 12/18/2012 10:04'!
render
	"return an Template within a string"

^'Inverted Section Test

Hash:
{
	"repo":[]
}

{{#repo}}
	<b>{{name}}</b>
{{/repo}}
{{^repo}}
	No repos :(
{{/repo}}
'! !

MustacheTemplate subclass: #MustacheTest8
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mustache-Tests'!

!MustacheTest8 methodsFor: 'as yet unclassified' stamp: 'JesusMari 9/23/2012 16:56'!
render
	"return an Template within a string"

^'Comments Test

<h1>Today{{!! a comment 

is an strange world}} is Monday!!</h1>

Lambdas test

Name:{{name}}, Profession:{{profession}}
Working at:{{company}}
------------------------------------------
Experience
{{#experience}}
{{job}}
{{/experience}}
------------------------------------------
Salary:
{{#wrapped}}
{{>Partial1}}
{{/wrapped}}
'! !

MustacheTest8 subclass: #Partial1
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mustache-Tests'!

!Partial1 methodsFor: 'as yet unclassified' stamp: 'JesusMari 9/23/2012 16:19'!
render
^'{{salary}}'! !

MustacheTest8 subclass: #Partial2
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mustache-Tests'!

MustacheTemplate subclass: #MustacheTest9
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mustache-Tests'!

!MustacheTest9 methodsFor: 'as yet unclassified' stamp: 'JesusMari 6/18/2012 13:18'!
render
	"return an Template within a string"

^'Set Delimiters Test

* {{default_tags}}
{{=<% %>=}}
* <% erb_style_tags %>
<%={{ }}=%>
*{{default_tags_again}}
'! !

MuSTemplate subclass: #MuSTest1
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mustache-Tests'!

!MuSTest1 methodsFor: 'as yet unclassified' stamp: 'JesusMari 2/20/2013 20:38'!
renderContentOn:html
html heading:'Simple test'.
html paragraph:('Hello' , html mustache variable:'name').
html paragraph:('you work as a' , html mustache variable:'profession')
! !

Object subclass: #MustacheTestRunner
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mustache-Tests'!

!MustacheTestRunner classSide methodsFor: 'as yet unclassified' stamp: 'JesusMari 9/30/2012 13:30'!
testCompileFile:aName
| mustache a tmp b c d |

a:=JsonObject new.
b:=JsonObject new.
c:=JsonObject new.
d:=JsonObject new.
a name:'Jesus Mar'.
d name:' alias "Jon".'.
a person:d.
a profession:'shift leader'.
a salary:2500.
a wrapped: [[:v :s| |retorno calc inner|
		"get the content"
		inner:= Mustache render: v asString view:s.
		retorno:='salary 13% of: ', inner.
		calc := ((s salary )- ((s salary) * 13 / 100)) asFloat .
		retorno := retorno , calc asString, ' Euros'.
		]] .
a inCa:true.
a company:'<b>Tirme</b>'.
b job:'Electrician'.
c job:'Singer'.
a experience: (Array with:b with:c).
a repo: Array new.
a funcion:[ 1*2*3*4 *100].

mustache:= Mustache instanceFromFolder: 'D:\smalltalk\SCouchViewServer\templates\'.
tmp:= mustache renderTemplateAt: aName view: a. 
Transcript show: tmp.
! !

!MustacheTestRunner classSide methodsFor: 'as yet unclassified' stamp: 'JesusMari 9/30/2012 14:02'!
testCompileTemplate:aTemplate
"run in workspace:   MustacheTestRunner testCompileTemplate: MustacheTestX"
| aStream a tmp b c d |
a:=JsonObject new.
b:=JsonObject new.
c:=JsonObject new.
d:=JsonObject new.
a name:'Jesus Mar'.
d name:' alias "Jon".'.
d funcion:[:ds|ds name].
a person:d.
a profession:'shift leader'.
a salary:2500.
a wrapped: [[:v :s| |retorno calc inner|
		"get the content"
		inner:= Mustache render: v asString view:s partials:self partials.
		retorno:='salary 13% of: ', inner.
		calc := ((s salary )- ((s salary) * 13 / 100)) asFloat .
		retorno := retorno , calc asString, ' Euros'.
		]] .
a inCa:true.
a company:'<b>Tirme</b>'.
b job:'Electrician'.
c job:'Singer'.
a experience: (Array with:b with:c).
a repo: Array new.
a funcion:[ :stash| (stash salary * 0.9) asString , ' Euros' ].

tmp:= Mustache render: aTemplate view:a.
Transcript show: tmp.


! !

!MustacheTestRunner methodsFor: 'as yet unclassified' stamp: 'JesusMari 9/22/2012 17:26'!
seeClassSide! !
